﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Text;
using RemoteTestRunner.BusinessLogic.Properties;

namespace RemoteTestRunner.BusinessLogic
{
    public static class RtrSettings
    {

        #region Properties

        private static bool _userSettings;

        static RtrSettings()
        {
            // test the settings base to see if user scope is available
            try
            {
                string temp;
                temp = Settings.Default.DataPath;
                _userSettings = true;
            }
            catch (ConfigurationErrorsException)
            {
                _userSettings = false;
            }
        }

        public static string DataPath
        {
            get
            {
                if (_userSettings)
                {
                    return Settings.Default.DataPath;
                }
                else
                {
                    return ConfigurationManager.AppSettings["DataPath"];
                }
            }

            set
            {
                Settings.Default.DataPath = value;
            }
        }

        public static string WorkingFolder
        {
            get
            {
                if (_userSettings)
                {
                    return Settings.Default.WorkingFolder;
                }
                else
                {
                    return ConfigurationManager.AppSettings["WorkingFolder"];
                }
            }

            set
            {
                Settings.Default.WorkingFolder = value;
            }
        }

        public static string MSTestPath
        {
            get
            {
                if (_userSettings)
                {
                    return Settings.Default.MSTestPath;
                }
                else
                {
                    return ConfigurationManager.AppSettings["MSTestPath"];
                }

            }

            set
            {
                Settings.Default.MSTestPath = value;
            }
        }

        public static int TestTimeoutSeconds
        {
            get
            {
                if (_userSettings)
                {
                    return Settings.Default.TestTimeoutSeconds;
                }
                else
                {
                    return int.Parse(ConfigurationManager.AppSettings["TestTimeoutSeconds"]);
                }
            }

            set
            {
                Settings.Default.TestTimeoutSeconds = value;
            }
        }

        public static bool UseRunnerService
        {
            get
            {
                if (_userSettings)
                {
                    return Settings.Default.UseRunnerService;
                }
                else
                {
                    return bool.Parse(ConfigurationManager.AppSettings["UseRunnerService"]);
                }
            }
            set { Settings.Default.UseRunnerService = value; }
        }

        public static string RunnerServiceUrl
        {
            get
            {
                if (_userSettings)
                {
                    return Settings.Default.RunnerServiceUrl;
                }
                else
                {
                    return ConfigurationManager.AppSettings["RunnerServiceUrl"];
                }
            }
            set { Settings.Default.RunnerServiceUrl = value; }
        }

        #endregion

        public static void Save()
        {
            Settings.Default.Save();
        }

    }
}
