﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using RemoteTestRunner.UnitTesting;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace RTRDiagnosisTests
{
    /// <summary>
    /// Summary description for UnitTest1
    /// </summary>
    [TestClass]
    public class DataDrivenSample2
    {
        public DataDrivenSample2()
        {
            ////
            // TODO: Add constructor logic here
            ////
        }

        /// <summary>
        /// Gets or sets the test context which provides
        /// information about and functionality for the current test run.
        /// </summary>
        public TestContext TestContext { get; set; }

        private static MultiAssertTestClassHelper _testClassHelper;

        #region Additional test attributes
        ////
        // You can use the following additional attributes as you write your tests:
        ////
        // Use ClassInitialize to run code before running the first test in the class
        [ClassInitialize()]
        public static void MyClassInitialize(TestContext testContext)
        {
            _testClassHelper = new MultiAssertTestClassHelper("DataDrivenSampleClean", testContext.TestDir);
        }

        ////
        // Use ClassCleanup to run code after all tests in a class have run
        [ClassCleanup()]
        public static void MyClassCleanup()
        {
            _testClassHelper.Dispose();
        }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        [DeploymentItem("RTRDiagnosisTests\\TestDataClean.xls")]
        [DataSource("DataDrivenSampleSourceClean")]
        public void TestMethod1_Clean()
        {
            // Setup function helper
            using (var functionHelper = _testClassHelper.GetFunctionHelper(TestContext))
            {
                // Setup inputs
                functionHelper
                    .AddInput("InputColumn", TestContext.DataRow["InputColumn"])
                    .AddInput("InputColumn2", TestContext.DataRow["InputColumn2"]);

                // Exercise code.  This would normally be the calls to your business methods
                int actualSum;
                int actualDifference;
                double actualDivision;

                actualSum = Convert.ToInt32(TestContext.DataRow["InputColumn"]) + Convert.ToInt32(TestContext.DataRow["InputColumn2"]);
                actualDifference = Convert.ToInt32(TestContext.DataRow["InputColumn"]) - Convert.ToInt32(TestContext.DataRow["InputColumn2"]);
                actualDivision = Convert.ToDouble(TestContext.DataRow["InputColumn"]) / Convert.ToDouble(TestContext.DataRow["InputColumn2"]);

                // Assert the business results
                functionHelper
                    .AreEqual<double>(TestContext.DataRow["OutputColumn1"], actualSum, "Sum test int", "OutputColumn1")
                    .AreEqual<double>(TestContext.DataRow["OutputColumn2"], actualDifference, "Difference test", "OutputColumn2")
                    .AreEqual<double>(TestContext.DataRow["OutputColumn3"], actualDivision, "Division test", "OutputColumn3");
            }
        }

        [TestMethod]
        [DeploymentItem("RTRDiagnosisTests\\TestDataClean.xls")]
        [DataSource("DataDrivenSampleSourceClean")]
        public void TestMethod2_Clean()
        {
            using (var functionHelper = _testClassHelper.GetFunctionHelper(TestContext))
            {
                functionHelper
                    .AddInput("InputColumn", TestContext.DataRow["InputColumn"])
                    .AddInput("InputColumn2", TestContext.DataRow["InputColumn2"]);

                int actualSum;
                int actualDifference;
                double actualDivision;

                actualSum = Convert.ToInt32(TestContext.DataRow["InputColumn"]) + Convert.ToInt32(TestContext.DataRow["InputColumn2"]);
                actualDifference = Convert.ToInt32(TestContext.DataRow["InputColumn"]) - Convert.ToInt32(TestContext.DataRow["InputColumn2"]);
                actualDivision = Convert.ToDouble(TestContext.DataRow["InputColumn"]) / Convert.ToDouble(TestContext.DataRow["InputColumn2"]);

                functionHelper
                    .AreEqual<double>(TestContext.DataRow["OutputColumn1"], actualSum, "Sum test int", "OutputColumn1")
                    .AreEqual<double>(TestContext.DataRow["OutputColumn2"], actualDifference, "Difference test", "OutputColumn2")
                    .AreEqual<double>(TestContext.DataRow["OutputColumn3"], actualDivision, "Division test", "OutputColumn3");
            }
        }
    }
}
