﻿using RemoteTestRunner.BusinessLogic.ViewModels;

namespace RemoteTestRunner.BusinessLogic
{
    public interface IApplicationNavigationService
    {
        /// <summary>
        ///   Shows the "Options" dialog.
        /// </summary>
        /// <param name = "viewModel">The view model.</param>
        void ShowOptions(object dataContext);

        void ShowProjectAdmin(object dataContext);

        void ViewDataSource(string dataSourcePath);

        /// <summary>
        ///   Shows the "About" dialog.
        /// </summary>
        /// <param name = "viewModel">The view model.</param>
        void ShowAbout(AboutViewModel viewModel);

        /// <summary>
        /// Displays the Remote Test Runner (RTR) on-line help.
        /// </summary>
        void DisplayOnlineHelp();
    }
}